var mapLink = "http://maps.googleapis.com/maps/api/staticmap?";
var defaultZoom = 14;
var defaultLength = 500;
var defaultWidth = 400;
var currentZoom = defaultZoom;
var imageURL = '';
/*The next two variables store the most recently obtained coordinates */
var currentLatitude = '';
var currentLongitude = '';
var mapType= "roadmap";
var mapDialog = '';
function getMap()
{
	if (navigator.geolocation != null)
	{
		var options;
		navigator.geolocation.getCurrentPosition(geolocationSuccess, geolocationError, options);
	}
	
	
}
function geolocationSuccess(position)
{
	/*Here we save the latitude from the position object. Do the same for the longitude */
	var latitude = position.coords.latitude;
	/*Use the showPosInfo(lat,lon) function to display the current coordinates to the screen */
	
	/*Set the global variables currentLongitude and currentLongitude equal to the newly determined position */


	
	/*Uncomment this portion of code when implementing map functionality
	imageURL = centerMapUrl(latitude,longitude,null,null,null);
	imageURL = imageURL + '&' + createMarker(latitude,longitude, 'red');
	insertImage(imageURL);
	*/
}
function geolocationError(error)
{
	alert("There was an error");
}
//Build a url for a map map centered around a single point
function centerMapUrl(lat,lon)
{

	var paramString = "center=" + encodeURI(lat) + ","+ encodeURI(lon)+ "&zoom=" + encodeURI(currentZoom);
	
	return mapLink+paramString +  "&sensor=false" + '&size=' + encodeURI(defaultLength) + 'x' + encodeURI(defaultWidth);
	
}
function createMarker(latitude,longitude,markerColor)
{
	var markerString =  encodeURI('markers=color:' + markerColor + '|' + latitude + "," +  longitude);
	return markerString;
}
function insertImage(url)
{

	var image  = $("<img />");
	image.attr("id","mapImage");
	//alert('URL: ' + url);
	image.attr("src",url);
	$("#imagediv img").remove();
	$("#imagediv").append(image);
}
function saveLocation()
{
	if ((currentLongitude == '') || (currentLatitude == ''))
	{
		alert("Please aquire new location data to save");
		return;	
	}
	var data = {};
	data.lat = currentLatitude;
	data.lon = currentLongitude;
	//Convert to json string so it can be saved in local session storage.
	var storageString = JSON.stringify(data);
	//alert(data);
	localStorage.locationData  = storageString;
	
}

function loadLocationData()
{
	//DEBUG
	var data = JSON.parse(localStorage.locationData);
	return data;
}
function showPosInfo(lat, lon)
{
	$("#latInfo").html('Latitude: ' +  lat);
	$("#lonInfo").html('Longitude: ' + lon);
}
/*Sets the currently selected map type */
function setMap(map)
{
/*This function uses jQuery to get teh value of the currently selected radio button */
	mapType = $("mapType form button:selected").attr("value");
}
function getOldLocation()
{
	var data = loadLocationData();
	var latitude = data.lat;
	var longitude = data.lon;
	var string = centerMapUrl(latitude,longitude,null,null,null) + '&' + createMarker(latitude,longitude,"blue");
	insertImage(string);
}
function increaseZoom()
{
	defaultZoom++;
}
function decreaseZoom()
{
	defaultZoom--;
}
function getRoute() 
{
	/*This segmeng of code uses functions that we defined previously to construct a parameter string which consists of two markers on a map with the map centered on the current location */
	var latitude = loadLocationData().lat;
	var longitude = loadLocationData().lon;
	var string = centerMapUrl(currentLatitude,currentLongitude,null,null,null) + '&' + createMarker(latitude,longitude,"blue") + '&' +  createMarker(currentLatitude, currentLongitude, "red");
	/*Add the latitude and longitude for the beginning and end of the path that is to shown on the map. This should b e done inside the call of the encodeURI() function */
	string = string  +  "&path=" + encodeURI(/*Finish parameters here*/);
	/*Add a call to the function insertImage, passing the variable 'string' as a parameter */
	
}

function showMapMenu() {
		mapDialog.dialog("open");
  }